﻿-- Addon: Bubble-Collector (version: 8.2.5) 2019.11.24
-- Description: AddOn collects bubble informations.
-- Autor: Platine  (e-mail: platine.wow@gmail.com)

-- Zmienne lokalne
local BC_name = UnitName("player");
local BC_class= UnitClass("player");
local BC_race = UnitRace("player");
local Y_Race1=UnitRace("player");
local Y_Race2=string.lower(UnitRace("player"));
local Y_Race3=string.upper(UnitRace("player"));
local Y_Class1=UnitClass("player");
local Y_Class2=string.lower(UnitClass("player"));
local Y_Class3=string.upper(UnitClass("player"));


-- funkcja tworząca Hash (32-bitowa liczba) podanego tekstu
local function StringHash(text)           
  local counter = 1;
  local pomoc = 0;
  local dlug = string.len(text);
  for i = 1, dlug, 3 do 
    counter = math.fmod(counter*8161, 4294967279);  -- 2^32 - 17: Prime!
    pomoc = (string.byte(text,i)*16776193);
    counter = counter + pomoc;
    pomoc = ((string.byte(text,i+1) or (dlug-i+256))*8372226);
    counter = counter + pomoc;
    pomoc = ((string.byte(text,i+2) or (dlug-i+256))*3932164);
    counter = counter + pomoc;
  end
  return math.fmod(counter, 4294967291) -- 2^32 - 5: Prime (and different from the prime in the loop)
end


-- Zmienne programowe zapisane na stałe na komputerze
function BC_CheckVars()
  if (not BC_PS) then
     BC_PS = {};
  end
  if (not BC_SAVED) then
     BC_SAVED = {};
  end
  -- inicjalizacja: dodatek aktywny
  BC_PS["locale"] = GetLocale();
  WOW_version, WOW_build, WOW_date, WOW_tocversion = GetBuildInfo();
  BC_PS["version"] = WOW_version;
  -- zmienna specjalna dostępności funkcji GetQuestID 
end


function BC_SaveBubble(self, event, arg1, arg2, arg3, _, arg5, ...)
   local original_txt = strtrim(arg1);
   local name_NPC = string.gsub(arg2, " says:", "");
   local target = arg5;
   local clear_txt = original_txt;
   if (arg5 ~= "") then
      clear_txt = string.gsub(clear_txt, arg5, "");        -- usuń osobę ($target) z tekstu oryginalnego
   end
   clear_txt = string.gsub(clear_txt, Y_Race1, "");        -- usuń rasę z tekstu
   clear_txt = string.gsub(clear_txt, Y_Race2, "");
   clear_txt = string.gsub(clear_txt, Y_Race3, "");
   clear_txt = string.gsub(clear_txt, Y_Class1, "");       -- usuń klasę z tekstu
   clear_txt = string.gsub(clear_txt, Y_Class2, "");
   clear_txt = string.gsub(clear_txt, Y_Class3, "");
   local HashCode = StringHash(clear_txt);
   BC_SAVED[tostring(HashCode)] = original_txt.."@"..target;
   BC_SAVED[tostring(HashCode).." PLAYER"]=BC_name..":"..BC_race..":"..BC_class..":"..GetLocale();
end


ChatFrame_AddMessageEventFilter("CHAT_MSG_MONSTER_SAY", BC_SaveBubble)
ChatFrame_AddMessageEventFilter("CHAT_MSG_MONSTER_PARTY", BC_SaveBubble)
ChatFrame_AddMessageEventFilter("CHAT_MSG_MONSTER_YELL", BC_SaveBubble)
ChatFrame_AddMessageEventFilter("CHAT_MSG_MONSTER_WHISPER", BC_SaveBubble)
ChatFrame_AddMessageEventFilter("CHAT_MSG_MONSTER_EMOTE", BC_SaveBubble)
BC_CheckVars();

DEFAULT_CHAT_FRAME:AddMessage("|cffffff00Bubble-Collector : addon is active and collects bubble texts");
